import { json_as_html } from "./core.mjs";



const demo = [
	"div",
	[
		["id", "wrapper"],
		["class", "demo_div"],
	],
	[
		["h1", [], "header :)"],
		["p", [], "paragraph! meow"],
		["p", [], "another paragraph!! this is so cool"],
		state => ["button", [
			["onclick", _ => {
				state.set("clicked", true);
				trigger_event("button_pressed");
			}]
		], "it can even do buttons!"],
		(state, after) => {
			// this is very messy.
			const generate = _ => ["p", [], state.get("clicked") ? "clicked" : "not clicked"];
			after(elem => listen_event("button_pressed", _ => elem.replaceWith(json_as_html(generate(), state))));

			return generate();
		},
		["ul",
			[],
			[
				["li", [], "meow"],
				["li", [], "uwu"],
			],
		],
	],
];

let event_listeners = new Map();

function trigger_event (name) {
	if (event_listeners.has(name)) {
		event_listeners.get(name).forEach(fn => fn());
	}
}

function listen_event (name, fn) {
	if (!event_listeners.has(name)) event_listeners.set(name, []);
	event_listeners.get(name).push(fn);
}

function render () {
	document.body.innerHTML = "";
	document.body.appendChild(json_as_html(demo));
}

render();
